/* 
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */


/* global Box2D */

function getinfo(fixt){
       var body=fixt.GetBody();
       var pos=body.GetPosition();
       var th=body.GetAngle();
       return{x:pos.x,y:pos.y,th:th};
    
}

function linev(ctx ,v1,v2,sc){
   ctx.lineWidth = 3;
    ctx.linestyle="yellow"
ctx.beginPath();
ctx.moveTo(v1.x*sc, v1.y*sc);
ctx.lineTo(v2.x*sc, v2.y*sc );
ctx.stroke();
 ctx.lineWidth = 1;
}
function rectbody(ctx,ob,rx,ry,sc,style){
    ctx.save();
   
    
            ctx.translate(ob.x*sc, ob.y*sc);
            ctx.rotate(ob.th);
            //ctx.scale(sx, sy);
            ctx.translate(-rx*sc, -ry*sc); 
 ctx.beginPath();
ctx.lineWidth = "6";
ctx.fillStyle = style;

ctx.rect(0,0,2*rx*sc,2*ry*sc);  
ctx.fill();
    
    ctx.restore();
    
}
function toggle(id) {
    var x = document.getElementById(id);
    if (x.style.display === "none") {
        x.style.display = "block";
    } else {
        x.style.display = "none";
    }
}

function show(id) {

    var x = document.getElementById(id);
    x.style.display = "block";


}
function hide(id) {

    var x = document.getElementById(id);
    x.style.display = "none";

}


function fclick(ob) {

    if (ob.id === "helpbutton")
        window.open('index_DS_II.html');
    if (ob.id === "help")
        hide('help');
    if (ob.id==="chdiv" ){
        
        
        
    }
}


function init() {
    var canvas = document.getElementById("canvas");
    var ctx=canvas.getContext("2d")
    var body = document.getElementById("body");
    var header = document.getElementById("header");
    var help = document.getElementById("help");
    var sc = 30;
    var jointdraw=false;
    var jv1,jv2;
    canvas.width = window.innerWidth;
    canvas.height = window.innerHeight;
    var b2Vec2 = Box2D.Common.Math.b2Vec2
            , b2AABB = Box2D.Collision.b2AABB
            , b2BodyDef = Box2D.Dynamics.b2BodyDef
            , b2Body = Box2D.Dynamics.b2Body
            , b2FixtureDef = Box2D.Dynamics.b2FixtureDef
            , b2Fixture = Box2D.Dynamics.b2Fixture
            , b2World = Box2D.Dynamics.b2World
            , b2MassData = Box2D.Collision.Shapes.b2MassData
            , b2PolygonShape = Box2D.Collision.Shapes.b2PolygonShape
            , b2CircleShape = Box2D.Collision.Shapes.b2CircleShape
            , b2DebugDraw = Box2D.Dynamics.b2DebugDraw
            , b2MouseJointDef = Box2D.Dynamics.Joints.b2MouseJointDef
            ;

    var world = new b2World(
            new b2Vec2(0, 10)    //gravity
            , true                 //allow sleep
            );

    var fixDef = new b2FixtureDef;
    fixDef.density = 1.0;
    fixDef.friction = 0.5;
    fixDef.restitution = 0.2;

    var bodyDef = new b2BodyDef;


    bodyDef.type = b2Body.b2_staticBody;
    fixDef.shape = new b2PolygonShape;
    fixDef.shape.SetAsBox(16, 2);
    bodyDef.position.Set(16, 16.78);// ground

    world.CreateBody(bodyDef).CreateFixture(fixDef);
    bodyDef.position.Set(16, -1.0); //up

    world.CreateBody(bodyDef).CreateFixture(fixDef);
    fixDef.shape.SetAsBox(2, 14);
    bodyDef.position.Set(-1.8, 13);//left
    world.CreateBody(bodyDef).CreateFixture(fixDef);

    bodyDef.position.Set(28.45, 13);//right
    world.CreateBody(bodyDef).CreateFixture(fixDef);


//create some objects
    var fixDef2 = new b2FixtureDef;
    fixDef.density = 1;
    fixDef2.density = 9;
    bodyDef.type = b2Body.b2_dynamicBody;


    fixDef.shape = new b2PolygonShape;
    fixDef.shape.SetAsBox(0.5, 0.5);

// fixDef.shape = new b2CircleShape( 0.5   );

    bodyDef.position.x = Math.random() * 10;
    bodyDef.position.y = Math.random() * 10;
    var c1 = world.CreateBody(bodyDef).CreateFixture(fixDef);

    fixDef2.shape = new b2PolygonShape;
    fixDef2.shape.SetAsBox(0.5, 0.5);

// fixDef.shape = new b2CircleShape( 0.5   );

    bodyDef.position.x = Math.random() * 10;
    bodyDef.position.y = Math.random() * 10;

    var c2 = world.CreateBody(bodyDef).CreateFixture(fixDef2);
////////////////////////////////////////////////////
   

//setup debug draw
    var debugDraw = new b2DebugDraw();
    debugDraw.SetSprite(ctx);
    debugDraw.SetDrawScale(sc);
    debugDraw.SetFillAlpha(0.50);
    debugDraw.SetLineThickness(0.0);
    debugDraw.SetFlags(b2DebugDraw.e_shapeBit | b2DebugDraw.e_jointBit);
    world.SetDebugDraw(debugDraw);

    window.setInterval(update, 1000 / 60);

//mouse

    var mouseX, mouseY, mousePVec, isMouseDown, selectedBody, mouseJoint;
    var canvasPosition = getElementPosition(document.getElementById("canvas"));
    onresize();
    function handleMouseDown(e) {
        isMouseDown = true;
        handleMouseMove(e);
        document.addEventListener("mousemove", handleMouseMove, true);
        document.addEventListener("touchmove", handleMouseMove, true);
    }

    document.addEventListener("mousedown", handleMouseDown, true);
    document.addEventListener("touchstart", handleMouseDown, true);
//////////////////////////////////////////////////////////////////
    addEventListener('resize', onresize, true);
    function onresize() {
        logh = 9;
        logw = 16;
        canvas.width = window.innerWidth;
        canvas.height = canvas.width * logh / logw;
        var px = 0;
        var py = (window.innerHeight - canvas.height) / 2;
        if (canvas.height > window.innerHeight) {
            canvas.height = window.innerHeight;
            canvas.width = canvas.height * logw / logh;
            py = 0;
            px = (window.innerWidth - canvas.width) / 2;
        }
//setelementpos(canvas, px, py);
        canvas.style.left = px + 'px';
        canvas.style.top = py + 'px';
        header.style.left = px + "px";
        header.style.width = canvas.width + "px";
        header.style.top = py + 'px';

        sc = canvas.height / 15;
        debugDraw.SetDrawScale(sc);
        canvasPosition = getElementPosition(document.getElementById("canvas"));
//    debugDraw.width = window.innerWidth;
//  debugDraw.height = window.innerHeight;
// body.width=canvas.width;
//    body.height=canvas.height ;
//    body.style.width=canvas.width;
//    body.style.height=canvas.height ;
// Box2D.onStageResize();   
    }

/////////////////////////////////////
    function handleMouseUp(e) {
        document.removeEventListener("mousemove", handleMouseMove, true);
        document.removeEventListener("touchmove", handleMouseMove, true);
        isMouseDown = false;
        mouseX = undefined;
        mouseY = undefined;
       
    }

    document.addEventListener("mouseup", handleMouseUp, true);
    document.addEventListener("touchend", handleMouseUp, true);

    function handleMouseMove(e) {
        var clientX, clientY;
        if (e.clientX)
        {
            clientX = e.clientX;
            clientY = e.clientY;
        } else if (e.changedTouches && e.changedTouches.length > 0)
        {
            var touch = e.changedTouches[e.changedTouches.length - 1];
            clientX = touch.clientX;
            clientY = touch.clientY;
        } else
        {
            return;
        }
        mouseX = (clientX - canvasPosition.x) / sc;
        mouseY = (clientY - canvasPosition.y) / sc;
        e.preventDefault();
    }
    ;

    function getBodyAtMouse() {
        mousePVec = new b2Vec2(mouseX, mouseY);
        var aabb = new b2AABB();
        aabb.lowerBound.Set(mouseX - 0.001, mouseY - 0.001);
        aabb.upperBound.Set(mouseX + 0.001, mouseY + 0.001);

// Query the world for overlapping shapes.

        selectedBody = null;
        world.QueryAABB(getBodyCB, aabb);
        return selectedBody;
    }

    function getBodyCB(fixture) {
        if (fixture.GetBody().GetType() !== b2Body.b2_staticBody) {
            if (fixture.GetShape().TestPoint(fixture.GetBody().GetTransform(), mousePVec)) {
                selectedBody = fixture.GetBody();
                return false;
            }
        }
        return true;
    }

//update
var md; 
    function update() {

        if (isMouseDown && (!mouseJoint)) {
            var body = getBodyAtMouse();
            if (body) {
                
 	
                 md = new b2MouseJointDef();
                md.bodyA = world.GetGroundBody();
                md.bodyB = body;
                md.target.Set(mouseX, mouseY);
                md.collideConnected = true;
                md.maxForce = 100.0// * body.GetMass();
                mouseJoint = world.CreateJoint(md);
                 
                body.SetAwake(true);
            }
        }
jv2=new b2Vec2(mouseX, mouseY);
jv1=new b2Vec2(10, 10);
        if (mouseJoint) {
           
             joindraw=true;
            
            if (isMouseDown) {
                 jv1= md.bodyB.GetJointList().joint.GetAnchorB();       
           
                jv2=new b2Vec2(mouseX, mouseY);
                mouseJoint.SetTarget(jv2);
            } else {
                world.DestroyJoint(mouseJoint);
                mouseJoint = null;
                joindraw=false;
            }
        }

        world.Step(1 / 60, 10, 10);
        
        world.DrawDebugData();
       ctx.beginPath();
     
 //var ob=getinfo(c1);
rectbody(ctx,getinfo(c1),0.5,0.5,sc,"red");
rectbody(ctx,getinfo(c2),0.5,0.5,sc,"blue");
 
  
 if (joindraw) linev(ctx,jv1,jv2,sc);
        
world.ClearForces();
    } ;

//helpers

//http://js-tut.aardon.de/js-tut/tutorial/position.html
    function getElementPosition(element) {
        var elem = element, tagname = "", x = 0, y = 0;

        while ((typeof (elem) === "object") && (typeof (elem.tagName) !== "undefined")) {
            y += elem.offsetTop;
            x += elem.offsetLeft;
            tagname = elem.tagName.toUpperCase();

            if (tagname === "BODY")
                elem = 0;

            if (typeof (elem) === "object") {
                if (typeof (elem.offsetParent) === "object")
                    elem = elem.offsetParent;
            }
        }

        return {x: x, y: y};
    }


}
;